#include	<Be.h>

void	scan_dev(BEntry e);
void	get_driver(const char *fn);

int main(int ac,char **ag)
{
	char	fn[256];
	if(ac<2)strcpy(fn,"/dev");
	else if(ac==2)strcpy(fn,ag[1]);
	else{printf("usage : getdrv device_path\n");return(1);}

	BEntry	e(fn);
	scan_dev(e);

	printf("ok\n");
	return(0);
}

void scan_dev(BEntry e)
{
	struct stat	dst;
	e.GetStat(&dst);
	if(dst.st_mode&S_IFDIR){
		BDirectory	dd(&e);
		int32	dce=dd.CountEntries();
		for(int i=0;i<dce;i++){
			BEntry	de;
			dd.GetNextEntry(&de);
			scan_dev(de);
		}
	}else{
		BPath	p;
		e.GetPath(&p);
		get_driver(p.Path());
	}
}

void get_driver(const char *fn)
{
if(!strcmp(fn,"/dev/bus/usb/unload"))return;		//KDL
if(!strncmp(fn,"/dev/input/",11))return;			//input-server down?
if(!strncmp(fn,"/dev/pt/",8))return;				//need not
if(!strncmp(fn,"/dev/tt/",8))return;				//need not
	driver_path	p;
	*p=0;
	int	fd=open(fn,O_RDONLY);
	if(fd<0)return;
	int	stt=ioctl(fd,B_GET_DRIVER_FOR_DEVICE,p);
	if(stt)return;
	printf("%s\t[%s]\n",fn,p);
	close(fd);
}
